#!/bin/sh
# config file for User Admin CGI package
# copyright 1998 by Thomas Linden
# This package is licensed under the terms of the GPL
# Feel free to redistribute or to modify it.
# Comments are welcome: tom@daemon.de
#
# You should know, that all cgi-bins in this package are
# shellscripts! As you know, shellscripts have a limited
# funktionality. This package is the result of a quick
# hack to let me do my job a little bit faster.
#
# If anybody want to rewrite the scripts to perl or whatever -
# just do it. 
#
# There are really no support provided with the scripts!
# Allways remember: You are using the scripts at your own risk.
# To let the risk be a minimum I have added backup capabilities 
# to the scripts. backups will be made by date, for example:
# $BACKUPDIR/admin-2400898/
# Backups will only made when a backup-directory with the current
# date doesn't exist. 
# If Backup was made, in the backup-directory will be located 
# all files, that we define below in the variables
# $PASSWD, $SHADOW, $ALIASES, $LIST, $USERS,
#
# If you want the script to make a backup everytime it runs,
# simply turn the variable $BACKUP_RUN to "no". See below.
# 
# Since the scripts runs all from your cgi-bin directory, you
# want to save this directory. The best way to do this, is
# to create a subdirectory in your cgi-bin and protect it
# with your webservers capabilities for authentication.
# Here is an example of my entry in /etc/httpd/access.conf:
#
# <Directory /usr/local/httpd/cgi-bin/manage>
# order allow,deny
# AllowOverride AuthConfig
# allow from all
# Options None
# </Directory>
#
# Don't forget to place a .htaccess file in this directory!
#
# Thomas Linden, tom@daemon.de
#
# Edit this file for your needs
# Every entry is commented, so you should probably know
# what you're doing:

####### Directories and Files #######

# Your CGI-BIN URL
	CGIDIR="http://mc200.cybernet-ag.net/cgi-bin/manage"

# The real Path to the cgi-bin's
	EXECDIR="/usr/local/httpd/cgi-bin/manage"

# Where should we copy backup files?
	BACKUPDIR="/etc/mail/backup"

# Where to place tmp files?
	TMPDIR="/tmp"

# Where are your Mailinglist files
	LISTDIR="/etc/mail/lists"

# The name of your list file
	LIST="$LISTDIR/uss.list"

# Where are the files needed for users home located?
	HOMEDIR="/home/default"

# Your passwd file
# Hint: Copy your real passwd-file to another (i.e. passwd.test)
# and test the scripts with this one!
	PASSWD="/etc/mail/lists/passwd"

# The Programm, we use to parse the cgi output
# Generally, you should not replace this line
	PARSE="$EXECDIR/proccgi"

# Your Shadow File
	SHADOW="/etc/mail/lists/shadow"

# Group File
	GROUP="/etc/mail/lists/group"

# Aliases File
	ALIASES="$LISTDIR/aliases"

# Users File (has to be included in aliases)
	USERS="$LISTDIR/uss.users"

# Mailinglist Archiv User, this user is not editable
	LIST_ARCHIV="uss-archiv"
 
# When should we do backup?
# If set to "no" we will make a backup only, if we could
# not find a backup-file from today
# If set to "yes" we will make a backup everytime the
# script runs
	BACKUP_RUN="no"

# Do you want me to edit your aliases/list/users files too?
# If not turn this parameter to "no". When set to "no", you 
# should fill out also the (not needed) variables pointing
# to aliases or list files. These data will only displayed,
# not manipulated!
# If you want it, turn it to "yes"
	MODIFY_ALL="yes"

# Should we log our activities?
# Set to "no", if you don't wish it
ADMIN_LOG="yes"

# Where should we write the Logs?
ADMIN_LOGFILE="/var/log/admin.log"

####### Colors and Titles #######

# Link color
	L_COL="\"#0000ff\""

# Visited link color
	VL_COL="\"#0000ff\""

# Background of the pages
	BG_COL="\"a0a0a0\""

# Background of the tables
	TAB_COL="\"#ffffff\""

# Color of table-headers
	HEAD_COL="\"#e0e0e0\""

# Color of table-titles
	TITLE_COL="\"#bbc0c0\""

# Title of these pages
	TITLE="Benutzer Verwaltung USS-ENTERPRISE"

# Title of Main table
	TAB_MAIN='Aktuell eingetragene User'

# Title of Edit table
	TAB_EDIT="User bearbeiten"

# Title of Del table
	TAB_DEL="User geloescht"

# Title of New table
	TAB_NEW="Neuen User erstellen"

# Title of Chpasswd Table
	TAB_CHPW="Passwort geaendert"

# Title of User Created Table
	TAB_CREAT="Neuen User erstellt"

# The caption of the "Back" link
BACK_CAPTION="Zur&uuml;ck"

#### Captions of the Links in main view (display.cgi)
	C_NEWUSER="<b>Neuen User anlegen</b>"
	C_SHOWCONFIG="Konfig zeigen"
	C_SHOWLIST="List Members zeigen"
	C_SHOWFILES="Dateien zeigen"
	C_DOCU="Dokumentation"

####### HTML Defines and functions ########
# For internally use                      #
# You should not replace something here   #
###########################################

HTML_START()
{ 
echo "Content-Type: text/html"
echo
echo
echo "<html><head>"
echo "<title>$TITLE</title>"
echo "</head><body bgcolor=$BG_COL link=$L_COL vlink=$VL_COL>"
echo "<h3 align=center>$TITLE</h3>"
echo "<center>"
echo "<a href=\"$CGIDIR/display.cgi\"><p>$BACK_CAPTION</p></a>"
}

HTML_END()
{
echo "<a href=\"$CGIDIR/display.cgi\"><p>$BACK_CAPTION</p></a>"
echo "<p></p><img src=\"http://admin.daemon.de/pic/msfree.gif\" border=0 alt=\"Any Questions?\">"
echo "</center></body></html>"
}


TABLE_HEAD()
{
echo "<center>"
echo "<table bgcolor=$TAB_COL border=2 cellspacing=2 cellpadding=1 width=500>"
echo "<tr><th height=2></th></tr>"
echo "<tr><th colspan=7 bgcolor=$TITLE_COL>$1 $2 $3 $4 $5 $6 $7 $8 $9</th></tr>"
echo "<tr><th height=2></th></tr>"
}



TABLE_END()
{
echo "<tr><th height=4></th></tr>"
echo "</table>"
# This is the function, every script runs at the end, so we 
# will clean from here our temp-files...
  rm $TMPDIR/new.*
}


CHECK_WRITE()
{
	# Helper-function, will be called from CHECK_RIGHTS()
	if [ -w $1 ]; then
		echo " " > /dev/null
	else
		HTML_START
		TABLE_HEAD ERROR CHECKING $1
		echo "<tr><td><b>Sorry, <br>Not all neccesary files and directories<br>"
		echo "were writable. Please see the README file of this package<br>"
		echo "and reconfigure your environment or contact your system-<br>"
		echo "administrator.</td></tr>"
		TABLE_END
		HTML_END
		exit 1
	fi
}


CHECK_RIGHTS()
{
	# Checks if we can write all files and directorys to do our job
	# otherwise we display a message. if this happens, you have to 
	# reconfigure your webserver :-(
	CHECK_WRITE $PASSWD
	CHECK_WRITE $SHADOW
	CHECK_WRITE $GROUP
	CHECK_WRITE $LIST
	CHECK_WRITE $USERS
	CHECK_WRITE $ALIASES
	CHECK_WRITE $BACKUPDIR
	CHECK_WRITE $ADMIN_LOGFILE
	CHECK_WRITE $HOMEDIR
	CHECK_WRITE /home
	CHECK_WRITE $TMPDIR	
}

MAKE_BACKUP()
{
	# Helper-function, will be called from BACKUP()
	# Ok, it's really simple, but it's doing the job :-)
	mkdir $BACKUPDIR/$1
	cp $2 $3 $4 $5 $6 $7 $BACKUPDIR/$1
	MAKE_LOG backup_created in $BACKUPDIR/$1
}


BACKUP()
{
# Create current day's directory-name
CDATE=`date +%j%m%y`
DIRNAME="admin-$CDATE"
case $BACKUP_RUN in
	"no")
		# Check if we can read the current dirname
		if [ -r $BACKUPDIR/$DIRNAME ]; then
			# yes we can, so do nothing
			echo " " > /dev/null
		else
			# no, we can't read it, so let's create the backup
			MAKE_BACKUP $DIRNAME $PASSWD $SHADOW $ALIASES $LIST $USERS $GROUP
		fi
		;;
	"yes")
		# OK, simply do it
		MAKE_BACKUP $DIRNAME $PASSWD $SHADOW $ALIASES $LIST $USERS $GROUP
		;;
esac
}

MAKE_LOG()
{
# Create an Syslog entry
case $ADMIN_LOG in
	"no")
		# do nothing
		echo " " > /edv/null
		;;
	"yes")
		# create log entry
		# $1 is the User, $2 is "modified", "created" or "deleted", $3 is for backup-logs only
		echo "`date`:  $1 $2 $3" >> $ADMIN_LOGFILE
		;;
esac
}


# Check if the programm is locked, if not, lock it
ADMIN_LOCK()
{
	if [ -r $EXECDIR/admin.lock ]; then
		# the programm is allready locked!
		HTML_START
		TABLE_HEAD ERROR!
		echo "<tr><td>The programm is currently in use!<br>"
		echo "Pleas try it later again!</td>"
		echo "<td><a href=\"$CGIDIR/display.cgi\">$BACK_CAPTION</a></td></tr>"
		TABLE_END
		HTML_END
		exit 1
	else
		# OK, it is not present, so let's create it!
		touch $EXECDIR/admin.lock
	fi
}


ADMIN_UNLOCK()
{
	# delete the Lcokfile, because we are ready
	rm $EXECDIR/admin.lock
}



# A Function to create a home directory
CREATE_HOME()
{
	mkdir /home/$1
	cp $HOMEDIR/.* /home/$1
	chown $1 /home/$1
	chown $1 /home/$1/.*
}




# Check the Version, we should use...
case $MODIFY_ALL in
        "no")
                MODIFY="modify_min.cgi"
                DELUSER="deluser_min.cgi"
                ;;
        "yes")
                MODIFY="modify.cgi"
                DELUSER="deluser.cgi"
                ;;
esac
 
# The only thing, we run from this script, is to check, if we
# can write all neccesary files and directories
CHECK_RIGHTS
