#!/bin/sh
#
#
# process form data
#

. ./config.sh

eval `$PARSE`

BACKUP

ADMIN_LOCK


case $FORM_pw in
   "")
	# Make passwd #############################################
	home="/home/$FORM_user"
	PASSWD_LINE="$FORM_user:x:$FORM_uid:$FORM_gid:$FORM_comment:$home:$FORM_shell"

	cat $PASSWD | awk -v user=$FORM_user 'BEGIN{FS=":";OFS=":"} \
	{if($1!=user) print $1,$2,$3,$4,$5,$6,$7} ' > $TMPDIR/new.passwd

	echo $PASSWD_LINE >> $TMPDIR/new.passwd

	cp $TMPDIR/new.passwd $PASSWD
	############################################################

        ########################### Modify Group Entry #######################
        echo $FORM_group > $TMPDIR/new.g
        for G in `cat $TMPDIR/new.g`
        do
                # First check if the user allready is in the group
                MATCH=`grep $G $GROUP | grep $FORM_user | cat`
                case $MATCH in
                        "")
                                # we have to modify this entry
                                MEMBERS=`cat $GROUP | awk -v group=$G 'BEGIN{FS=":"} \
                                {if($1==group) print $4}' | cat`
                                # Check if other users are here
                                case $MEMBERS in
                                        "")
                                                # no, so we are the first one
                                                NEWMEMBERS="$FORM_user"
                                                ;;
                                        *)
                                                # yes, let's add the user
                                                NEWMEMBERS="$MEMBERS,$FORM_user"
                                                ;;
                                esac
                                cat $GROUP | awk -v group=$G -v members=$NEWMEMBERS 'BEGIN{FS=":"} \
                                {if($1!=group) print $0} \
                                {if($1==group)print$1":"$2":"$3":"members}' > $TMPDIR/new.group
                                cp $TMPDIR/new.group $GROUP
                                ;;
                        *)
                                # The user is in the group, don't modify the entry
                                echo
                                ;;
                esac
        done

        # Now, check if the user is in a group, he shouldn't be
        for GR in `cat $GROUP`
        do
                MEM=`echo $GR | grep $FORM_user`
                case $MEM in
                        "")
                                # the user isn't in the group. Write this entry to the new groupfile
                                echo $GR >> $TMPDIR/new.delgroup
                                ;;
                        *)
                                # we have found the user in this group
                                # check if this is a group, where the user should not be
                                TGR=`echo $GR | awk 'BEGIN{FS=":"}{print $1}' | cat`
                                RES=`grep $TGR $TMPDIR/new.g | cat`
                                case $RES in
                                        "")
                                                # we have to delete the user from this group
                                                T1=`echo $GR | awk 'BEGIN{FS=":"}{print $4}' | cat`
                                                case $T1 in
                                                "$FORM_user")
                                                        echo $GR | awk 'BEGIN{FS=":"} \
                                                        {print$1":"$2":"$3":"}' >> $TMPDIR/new.delgroup
                                                        ;;
                                                *)
                                                        NLINE=`echo $T1 | sed 's/'$FORM_user'/, /g' | sed 's/, ,//g' | sed 's/,, //g'`
                                                        echo $GR | awk -v line=$NLINE 'BEGIN{FS=":"} \
                                                        {print $1":"$2":"$3":"line}' >> $TMPDIR/new.delgroup
                                                        ;;
                                                esac
                                                ;;
                                        *)
                                                # the user can stay here, do nothing
                                                echo $GR >> $TMPDIR/new.delgroup
                                                ;;
                                esac
                                ;;
                esac
        done
        cp $TMPDIR/new.delgroup $GROUP


	HTML_START
	TABLE_HEAD User modified
	echo "<tr>"
	echo "<td>User <b>$FORM_user</b> modified</td>"
	echo "</tr>"
	echo "<td><a href=\"$CGIDIR/display.cgi\">$BACK_CAPTION</a></td>"
	echo "<tr><th height=4></th></tr>"
	TABLE_END
	HTML_END
	MAKE_LOG $FORM_user modified
	ADMIN_UNLOCK
	exit 0
	;;
   *)
	# Make shadow ##############################################
	HTML_START
        
	case $FORM_chpw in
	"yes")
		# OK, we come from chpasswd.cgi
		case $FORM_pw in
			"$FORM_pw2")
				# Was the PW's the same?
        			CR_PASSWD=`$EXECDIR/mkpasswd $FORM_pw | cat`
        			SHADOW_LINE="$FORM_user:$CR_PASSWD:10460:0:10000::::"
        			cat $SHADOW | awk -v user=$FORM_user 'BEGIN{FS=":";OFS=":"} \
        			{if($1!=user) print $1,$2,$3,$4,$5,$6,$7,$8,$9}' > $TMPDIR/new.shadow
        			echo $SHADOW_LINE >> $TMPDIR/new.shadow
        			cp $TMPDIR/new.shadow $SHADOW
				TABLE_HEAD $TAB_CHPW
                		echo "<tr>"
                		echo "<td>Password for <b>$FORM_user</b> changed."
				echo "<td><a href=\"$CGIDIR/display.cgi\">$BACK_CAPTION</a></td>"
				MAKE_LOG $FORM_user password_changed
				;;
			*)
				# They was not the same
				TABLE_HEAD ERROR
		                echo "<tr>"
                		echo "<td><font color="#ff0000" size=5><b>Error!</b></font><br>"
				echo "</br> Field 1 and Field 2 was not the same.<br>"
				echo "</br>Password for <b>$FORM_user</b> was NOT changed!"
				;;
		esac
		;;
	*)
		# We come from newuser.cgi
		FOUND=`grep $FORM_user $SHADOW | cat`
                case $FOUND in
                        "")
				# User not found, so let's create one
				CR_PASSWD=`$EXECDIR/mkpasswd $FORM_pw | cat`
                		SHADOW_LINE="$FORM_user:$CR_PASSWD:10460:0:10000::::"
                		cat $SHADOW | awk -v user=$FORM_user 'BEGIN{FS=":";OFS=":"} \
                		{if($1!=user) print $1,$2,$3,$4,$5,$6,$7,$8,$9}' > $TMPDIR/new.shadow
                		echo $SHADOW_LINE >> $TMPDIR/new.shadow
                		cp $TMPDIR/new.shadow $SHADOW

				 GRID=`cat $GROUP | awk -v group=$FORM_group 'BEGIN{FS=":"}\
                                {if($1==group)print $3}' | cat`
                                PASSWD_LINE="$FORM_user:x:$FORM_uid:$GRID:$FORM_comment:$home:$FORM_shell"
                                echo $PASSWD_LINE >> $PASSWD


				CREATE_HOME $FORM_user
				
                                # Create a group entry
                                MEMBERS=`cat $GROUP | awk -v group=$FORM_group 'BEGIN{FS=":"} \
                                {if($1==group) print $4}' | cat`
                                # Check if other users are here
                                case $MEMBERS in
                                        "")
                                                # no, so we are the first one
                                                NEWMEMBERS="$FORM_user"
                                                ;;
                                        *)
                                                # yes, let's add the user
                                                NEWMEMBERS="$MEMBERS,$FORM_user"
                                                ;;
                                esac
                                cat $GROUP | awk -v group=$FORM_group -v members=$NEWMEMBERS 'BEGIN{FS=":"} \
                                {if($1!=group) print $0} \
                                {if($1==group)print $1":"$2":"$3":"members}' > $TMPDIR/new.group
                                cp $TMPDIR/new.group $GROUP



				TABLE_HEAD $TAB_CREAT
				echo "<tr>"
				echo "<td>User <b>$FORM_user</b> created</td>"
				echo "<td><a href=\"$CGIDIR/display.cgi\">$BACK_CAPTION</a></td>"
				MAKE_LOG $FORM_user created
				;;
			*)
                               # User exits
                                TABLE_HEAD ERROR
                                echo "<tr>"
                                echo "<td><font color="#ff0000" size=5><b>Error!</b></font><br>"
                                echo "</br>User Allready exits!<br>"
                                echo "</br><b>$FORM_user</b> was NOT created!"
                                ;;
		esac
		;;        
	esac

        echo "</tr>"
        echo "<tr><th height=4></th></tr>"
        TABLE_END
        HTML_END
	ADMIN_UNLOCK
        exit 0
        ;;
esac
